package typeclasses

/**
 * Defines the Functor operations for any type of kind F[_]. Functors allow for
 * a function to be applied to a value lifted into F[_].
 */
trait Functor[F[_]] {

  /**
   * Applies a lifted value to a function.
   */
  def map[A, B](fa: F[A])(f: A => B): F[B]
}
